using System;
using System.Runtime.InteropServices;
using System.Web.UI;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Serialization;

using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Microsoft.SharePoint.WebPartPages;
using System.Collections.Generic;
using Telerik.Web.UI;

namespace WebPart1
{
    [Guid("faa44d1c-5ba1-40d8-b833-9656b3326d77")]
    public class WebPart1 : System.Web.UI.WebControls.WebParts.WebPart
    {
        private void EnsureUpdatePanelFixups()
        {
            if (this.Page.Form != null)
            {
                string formOnSubmitAtt = this.Page.Form.Attributes["onsubmit"];
                if (formOnSubmitAtt == "return _spFormOnSubmitWrapper();")
                {
                    this.Page.Form.Attributes["onsubmit"] = "_spFormOnSubmitWrapper();";
                }
            }

            ScriptManager.RegisterStartupScript(this.Page, typeof(Page), "UpdatePanelFixup", "_spOriginalFormAction = document.forms[0].action; _spSuppressFormOnSubmitWrapper=true;", true);
        }

        protected override void Render(HtmlTextWriter writer)
        {
            EnsureUpdatePanelFixups();
            base.Render(writer);
        }

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
            //ScriptManager manager = ScriptManager.GetCurrent(Page);
            //if (manager == null)
            //{
            //    manager = new ScriptManager();
            //    manager.ID = "ScriptManager1";
            //    Page.Form.Controls.Add(manager);
            //}
            EnsureChildControls();
        }
        protected override void CreateChildControls()
        {

            RadScheduler radScheduler = new RadScheduler();
            radScheduler.ID = "radScheduler";

            radScheduler.DataKeyField = "ID";
            radScheduler.DataStartField = "Start";
            radScheduler.DataEndField = "End";
            radScheduler.DataSubjectField = "Subject";
            radScheduler.DataRecurrenceField = "RecurrenceRule";
            radScheduler.DataRecurrenceParentKeyField = "RecurrenceParentID";
            radScheduler.WeekView.UserSelectable = true;
            radScheduler.MonthView.UserSelectable = true;
            radScheduler.TimelineView.UserSelectable = true;
            BindScheduler(radScheduler);


            RadAjaxPanel ajaxPanel = new RadAjaxPanel();
            ajaxPanel.ID = "AjaxPanel";

            Controls.Add(ajaxPanel);
            ajaxPanel.Controls.Add(new LiteralControl("aaaaaaaaaaaaaaa"));
            ajaxPanel.Controls.Add(radScheduler);

            base.CreateChildControls();
        }

        private void BindScheduler(RadScheduler radScheduler)
        {
            List<AppointmentUI> sessAppts; //= Page.Session["appts"] as List<AppointmentUI>;
            //if (sessAppts == null)
            //{
            sessAppts = new List<AppointmentUI>();
            //    Page.Session["appts"] = sessAppts;
            //}

            radScheduler.DataSource = sessAppts;
        }        
    }    
    public class AppointmentUI
    {
        private int databaseId;
        private DateTime end;
        private string id;
        private string recurData;
        private string recurParentID;
        //private RecurrenceState recurState;
        private DateTime start;
        private string subject;

        private AppointmentUI()
        {
            id = Guid.NewGuid().ToString();
        }
        public AppointmentUI(string subject, DateTime start, DateTime end)
            : this()
        {
            this.subject = subject;
            this.start = start;
            this.end = end;
        }
        public AppointmentUI(Appointment source)
            : this()
        {
            CopyInfo(source);
        }

        public string ID
        {
            get { return id; }
            set { id = value; }
        }

        public int DatabaseId
        {
            get { return databaseId; }
            set { databaseId = value; }
        }

        public string Subject
        {
            get { return subject; }
            set { subject = value; }
        }
        public DateTime Start
        {
            get { return start; }
            set { start = value; }
        }
        public DateTime End
        {
            get { return end; }
            set { end = value; }
        }
        public string RecurrenceRule
        {
            get { return recurData; }
            set { recurData = value; }
        }
        public string RecurrenceParentID
        {
            get { return recurParentID; }
            set { recurParentID = value; }
        }
        //public RecurrenceState RecurrenceState
        //{
        //    get { return recurState; }
        //    set { recurState = value; }
        //}

        public void CopyInfo(Appointment source)
        {
            subject = source.Subject;
            start = source.Start;
            end = source.End;
            //recurState = source.RecurrenceState;
            recurData = source.RecurrenceRule;
            if (source.RecurrenceParentID != null)
            {
                recurParentID = source.RecurrenceParentID.ToString();
            }
        }
        public override bool Equals(object obj)
        {
            if (obj is AppointmentUI)
            {
                AppointmentUI a = (AppointmentUI)obj;
                if (ID == a.ID)
                    return true;
            }
            return false;
        }
        public override int GetHashCode()
        {
            return ID.GetHashCode();
        }
    }
    
}
